import java.io.*;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class kzp_av {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        FastScanner in = new FastScanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        CHGK solver = new CHGK();
        solver.solve(1, in, out);
        out.close();
    }

    static class CHGK {
        static final int MOD = 998244353;

        public void solve(int testNumber, FastScanner in, PrintWriter out) {
            int n = in.nextInt(), k = in.nextInt(), s = in.nextInt();
            int[] questions = in.nextIntArray(k);
            for (int i = 0; i < k; i++) {
                if (questions[i] == s) {
                    s = i;
                    break;
                }
            }
            int[][] choose = MathUtils.choose(k + 1, k + 1, MOD);
            int[][] dp = new int[k + 1][k];
            dp[0][0] = 1;
            for (int pos = 0; pos < k; pos++) {
                long mul = 1;
                {
                    int curPos = (s - pos + k) % k;
                    int prevPos = (s - (pos + 1) + k) % k;
                    mul = questions[curPos] - questions[prevPos];
                    if (curPos < prevPos) {
                        mul += n;
                    }
                }
                mul = mul * MathUtils.inv(n, MOD) % MOD;
                for (int cur = 0; cur < k; cur++) {
                    long val = dp[pos][cur];
                    long curMul = 1;
                    for (int add = 0; cur + add <= pos; add++) {
                        dp[pos + 1][cur + add] += val * curMul % MOD * choose[cur + add][add] % MOD;
                        if (dp[pos + 1][cur + add] >= MOD) {
                            dp[pos + 1][cur + add] -= MOD;
                        }
                        curMul = curMul * mul % MOD;
                    }
                }
            }
            long expected = 0;
            for (int i = 0; i < k; i++) {
                expected += dp[k][i];
            }
            out.println(expected % MOD);
        }

    }

    static class FastScanner {
        public BufferedReader br;
        public StringTokenizer st;

        public FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        public FastScanner(String fileName) {
            try {
                br = new BufferedReader(new FileReader(fileName));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public String next() {
            while (st == null || !st.hasMoreElements()) {
                String line = null;
                try {
                    line = br.readLine();
                } catch (IOException e) {
                    throw new UnknownError();
                }
                if (line == null) {
                    throw new UnknownError();
                }
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public int[] nextIntArray(int n) {
            int[] ret = new int[n];
            for (int i = 0; i < n; i++) {
                ret[i] = nextInt();
            }
            return ret;
        }

    }

    static class MathUtils {
        public static long modPow(long a, long b, long mod) {
            while (a < 0) {
                a += mod;
            }
            long res = 1;
            while (b > 0) {
                if ((b & 1) != 0) {
                    res = res * a % mod;
                }
                a = a * a % mod;
                b >>>= 1;
            }
            return res;
        }

        public static long inv(long a, long mod) {
            return modPow(a, mod - 2, mod);
        }

        public static int[][] choose(int n, int m, int mod) {
            int[][] choose = new int[n][m];
            for (int i = 0; i < n; i++) {
                choose[i][0] = 1;
                for (int j = 1; j < m && j <= i; j++) {
                    choose[i][j] = choose[i - 1][j - 1] + choose[i - 1][j];
                    if (choose[i][j] >= mod) {
                        choose[i][j] -= mod;
                    }
                }
            }
            return choose;
        }

    }
}

